Name: libdb4
Version: 4.0.14
Release: alt8
%define _sover %(echo %version |cut -d. -f-2)
%define srcname db-%version

Summary: Berkeley database library
License: GPL
Group: System/Libraries
Url: http://www.sleepycat.com/
Packager: Berkeley DB Development Team <db@packages.altlinux.org>

Source: http://www.sleepycat.com/update/%version/%srcname.tar.bz2
Patch1: db-4.0.14-rh-recover.patch
Patch2: db-3.3.11-alt-makefile.patch
Patch3: db-3.3.11-rh-ham_dirty_meta.patch
Patch4: db-4.0.14-alt-gcc296.patch
Patch5: db-4.0.14-rh-configure.patch

Provides: db4 = %version
Obsoletes: db4
Conflicts: glibc <= 6:2.1.3

%def_enable compat185
%def_enable cxx
%def_disable debug
%{?_enable_debug:%def_enable debug_rop}
%{!?_enable_debug:%def_disable debug_rop}
%{?_enable_debug:%def_enable debug_wop}
%{!?_enable_debug:%def_disable debug_wop}
%{?_enable_debug:%def_enable diagnostic}
%{!?_enable_debug:%def_disable diagnostic}
%def_enable dump185
%def_enable java
%def_disable posixmutexes
%def_enable rpc
%def_enable tcl
%def_disable test
%def_disable uimutexes 
%def_disable umrw

BuildPreReq: coreutils, rpm >= 4.0.4-alt1, tcl-devel >= 8.4.0-alt1

# Automatically added by buildreq on Tue Nov 12 2002
BuildRequires: gcc-c++ gcc-java glibc-devel-static jdkgcj libdb1-devel libgcj-devel libstdc++-devel tcl-devel

%package -n db4-utils
Summary: Command line tools for managing Berkeley DB databases
Group: Databases
Requires: %name = %version-%release
Conflicts: db3-utils

%package devel
Summary: Development environment for Berkeley database library
Group: Development/C
Requires: %name = %version-%release, db4-utils = %version-%release
Provides: db4-devel = %version
Obsoletes: db4-devel
Conflicts: libdb3-devel
BuildConflicts: %name-devel

%package devel-static
Summary: Static version of Berkeley database library
Group: Development/C
Requires: %name-devel = %version-%release
Provides: db4-devel-static = %version
Obsoletes: db4-devel-static
Conflicts: libdb3-devel-static
BuildConflicts: %name-devel-static

%package -n %{name}_cxx
Summary: C++ Development environment for Berkeley database library
Group: System/Libraries
Requires: %name = %version-%release

%package -n %{name}_cxx-devel
Summary: C++ Development environment for Berkeley database library
Group: Development/C++
Requires: %name-devel = %version-%release
Requires: %{name}_cxx = %version-%release

%package -n %{name}_cxx-devel-static
Summary: C++ Development environment for Berkeley database library
Group: Development/C++
Requires: %name-devel-static = %version-%release
Requires: %{name}_cxx-devel = %version-%release

%package -n %{name}_tcl
Summary: Tcl Development environment for Berkeley database library
Group: System/Libraries
Requires: %name = %version-%release
Conflicts: libdb3_tcl

%package -n %{name}_tcl-devel
Summary: Tcl Development environment for Berkeley database library
Group: Development/Tcl
Requires: %name-devel = %version-%release
Requires: %{name}_tcl = %version-%release
Conflicts: libdb3_tcl-devel

%package -n %{name}_tcl-devel-static
Summary: Tcl Development environment for Berkeley database library
Group: Development/Tcl
Requires: %name-devel-static = %version-%release
Requires: %{name}_tcl-devel = %version-%release
Conflicts: libdb3_tcl-devel-static

%package -n %{name}_java
Summary: Java Development environment for Berkeley database library
Group: System/Libraries
Requires: %name = %version-%release

%package -n %{name}_java-devel
Summary: Java Development environment for Berkeley database library
Group: Development/Java
Requires: %name-devel = %version-%release
Requires: %{name}_java = %version-%release

%package -n %{name}_java-devel-static
Summary: Java Development environment for Berkeley database library
Group: Development/Java
Requires: %name-devel-static = %version-%release
Requires: %{name}_java-devel = %version-%release

%package doc
Summary: Documentation for Berkeley database library
Group: Development/Other

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB is used by many applications, including Python and Perl, so this
should be installed on all systems.

%description -n db4-utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains command line tools for managing Berkeley DB databases.

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains the header files and libraries for
building programs which use Berkeley DB.

%description devel-static
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains static libraries for building statically linked programs
which use Berkeley DB.

%description -n %{name}_cxx
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains C++ API library.

%description -n %{name}_cxx-devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains libraries and header files for building programs using C++ API.

%description -n %{name}_cxx-devel-static
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains static libraries for C++ API.

%description -n %{name}_tcl
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains Tcl API library.

%description -n %{name}_tcl-devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains libraries for building programs using Tcl API.

%description -n %{name}_tcl-devel-static
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains static libraries for Tcl API.

%description -n %{name}_java
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains Java API library.

%description -n %{name}_java-devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains libraries and header files for building programs using
Java API.

%description -n %{name}_java-devel-static
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains static libraries for Java API.

%description doc
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains documentation for developers.

%prep
%setup -q -n %srcname
chmod -R u+w .
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

#pushd dist
#	./s_config
#popd

%build
# needed for tcl >= 8.4
%add_optflags -DUSE_NON_CONST
%define _configure_script ../dist/configure

pushd build_unix
	%configure \
		%{subst_enable compat185} \
		%{subst_enable cxx} \
		%{subst_enable debug} \
		%{subst_enable debug_rop} \
		%{subst_enable debug_wop} \
		%{subst_enable dump185} \
		%{subst_enable diagnostic} \
		%{subst_enable java} \
		%{subst_enable posixmutexes} \
		%{subst_enable rpc} \
		%{subst_enable tcl} \
		%{subst_enable test} \
		%{subst_enable uimutexes} \
		%{subst_enable umrw} \
		--with-tcl=%_libdir
	# SMP-incompatible build.
	make
popd

%__rm -f examples_*/tags

%install
%__mkdir_p $RPM_BUILD_ROOT{/lib,%_libdir,%_tcllibdir,%_tcldatadir/Db_tcl,%_includedir/db4}

%define docdir %_docdir/%name-%version
%makeinstall -C build_unix docdir=$RPM_BUILD_ROOT%docdir

%__install -p -m644 README LICENSE $RPM_BUILD_ROOT%docdir/
%__cp -pRL examples_* $RPM_BUILD_ROOT%docdir/

%define _libdb_a	libdb-%_sover.a
%define _libdb_so	libdb-%_sover.so

pushd $RPM_BUILD_ROOT
	%__mv .%_libdir/libdb-*.so lib/
	%__ln_s -nf ../../lib/%_libdb_so .%_libdir/libdb.so

	%__mv .%_libdir/libdb_tcl* .%_tcllibdir/

	%__mv .%_includedir/*.h .%_includedir/db4/
	%__ln_s db4/db.h .%_includedir/db.h
	#for F in .%prefix/bin/db_*; do
	#	mv "$F" "${F/db_/db4_}"
	#done
popd

%__ln_s ../../lib/%_libdb_so $RPM_BUILD_ROOT%_libdir/

chmod a+x $RPM_BUILD_ROOT%_libdir/*.so

%tea_makeindex -v -f libdb_tcl-%_sover.so -C $RPM_BUILD_ROOT%_tcldatadir/Db_tcl

%if_enabled java
# Move java jar file to the correct place.
%__mkdir_p $RPM_BUILD_ROOT%_datadir/java
%__mv $RPM_BUILD_ROOT%_libdir/*.jar $RPM_BUILD_ROOT%_datadir/java/
%endif

%post -p %post_ldconfig_sys
%postun -p %postun_ldconfig

%post -n %{name}_cxx -p %post_ldconfig
%postun -n %{name}_cxx -p %postun_ldconfig

%post -n %{name}_java -p %post_ldconfig
%postun -n %{name}_java -p %postun_ldconfig

%files
/lib/*.so
%_libdir/libdb-[0-9]*.so
%dir %docdir
%doc %docdir/[A-Z]*

%if_enabled cxx
%files -n %{name}_cxx
%_libdir/*_cxx-[0-9].[0-9].so

%files -n %{name}_cxx-devel
%_libdir/*_cxx.so
%_libdir/*_cxx-[0-9].so
%_libdir/*_cxx*.la
%_includedir/*/*cxx*

%files -n %{name}_cxx-devel-static
%_libdir/*_cxx*.a
%endif #cxx

%if_enabled tcl
%files -n %{name}_tcl
%_tcllibdir/*_tcl-[0-9].[0-9].so
%_tcldatadir/Db_tcl

%files -n %{name}_tcl-devel
%_tcllibdir/*_tcl.so
%_tcllibdir/*_tcl-[0-9].so
%_tcllibdir/*_tcl*.la

%files -n %{name}_tcl-devel-static
%_tcllibdir/*_tcl*.a
%endif #tcl

%if_enabled java
%files -n %{name}_java
%_libdir/*_java-[0-9].[0-9].so
%_datadir/java/*.jar

%files -n %{name}_java-devel
%_libdir/*_java.so
%_libdir/*_java-[0-9].so
%_libdir/*_java-[0-9].[0-9]_g.so
%_libdir/*_java*.la

%files -n %{name}_java-devel-static
%_libdir/*_java*.a
%endif #java

%files -n db4-utils
%_bindir/*

%files devel
%_libdir/libdb.so
%_libdir/libdb-[0-9]*.la
%_includedir/*
%if_enabled cxx
%exclude %_includedir/*/*cxx*
%endif

%files doc
%dir %docdir
%doc %docdir/[a-z]*

%files devel-static
%_libdir/libdb.a
%_libdir/libdb-[0-9]*.a

%changelog
* Wed Nov 13 2002 Dmitry V. Levin <ldv@altlinux.org> 4.0.14-alt8
- Relocated db.jar from %_libdir/ to %_datadir/java/.

* Mon Nov 11 2002 Dmitry V. Levin <ldv@altlinux.org> 4.0.14-alt7
- Added patch from Sleepycat to avoid db_recover (rh #70362).
- Fixed includedir problem (rh).
- Enabled java support.

* Sat Oct 12 2002 Dmitry V. Levin <ldv@altlinux.org> 4.0.14-alt6
- Fixed docs installation due to coreutils-4.5.2-alt1.

* Wed Oct  2 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 4.0.14-alt5
- rebuilt with tcl 8.4
- tcl package index added

* Tue Sep 03 2002 Stanislav Ievlev <inger@altlinux.ru> 4.0.14-alt4
- super split. New subpackages:
    * for c++
    * for tcl
    * documentation

* Mon Aug 12 2002 Stanislav Ievlev <inger@altlinux.ru> 4.0.14-alt3
- Rebuild with new tcl layout

* Sat Mar 30 2002 Dmitry V. Levin <ldv@alt-linux.org> 4.0.14-alt2
- Implemented new %%def_enable/%%_def_disable specfile logic.
- Build with diagnostic disabled by default.
- Use postun_ldconfig.

* Wed Mar 13 2002 Dmitry V. Levin <ldv@alt-linux.org> 4.0.14-alt1
- 4.0.14
- Fixed permissions on shared libraries (0000543).
- Dropped db_chroot_prefix hack.
- Conflicts: db3-utils, libdb3-devel, libdb3-devel-static.

* Mon Dec 10 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.3.11-alt4
- Fixed db_chroot_prefix hack (jbj).

* Wed Dec 05 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.3.11-alt3
- Added db_chroot_prefix hack.
- Added compatibility symlink to shared library.
- Dropped compatibility symlink to static library.

* Thu Oct 25 2001 Dmitry V. Levin <ldv@alt-linux.org> 3.3.11-alt2
- Added ham_dirty_meta patch from Sleepycat.
- Added compatibility symlink to static library.

* Tue Sep 25 2001 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.3.11-alt1
- 3.3.11 release.
- Renamed library subpackages.
- Corrected interpackage requires.
- Moved static libraries to devel-static subpackage.
- Moved %_includedir/db_185.h symlink to libdb2-devel package.

* Fri Feb 02 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.9-ipl2mdk
- Added noticecall callback interface
  (by Alexander Bokovoy <ab@avilink.net>).

* Fri Feb 02 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.9-ipl1mdk
- 3.2.9 release.
- Enabled LFS support.
- Explicitly set strip methods.

* Mon Jan 15 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.3e-ipl2mdk
- Fixed db_185.h

* Thu Jan 04 2001 Dmitry V. Levin <ldv@fandra.org> 3.2.3e-ipl1mdk
- New version for MaxSQL's transactions support.
- Disabled posixmutexes again.

* Sat Nov 11 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.17-ipl3mdk
- Rebuild with glibc-2.2 and for glibc-2.2.
- Docs cleanup.
- Enabled C++ api.
- Enabled posixmutexes.
- Fixed static/shared build.

* Sun Oct 01 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.17-ipl2mdk
- Rebuilt with glibc-2.1.94 & gcc-2.96.
- Defined _noVersionedDependencies.
- Automatically added BuildRequires.

* Mon Aug 21 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.17-ipl1mdk
- 3.1.17.

* Fri Aug 18 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.14-ipl1mdk
- RE and Fandra adaptions.

* Sun Jun 11 2000 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.1.14.
- create db3-utils sub-package to hide tcl dependency, enable tcl Yet Again.
- FHS packaging.

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- disable tcl Yet Again, base packages cannot depend on libtcl.so.

* Sat Jun  3 2000 Jeff Johnson <jbj@redhat.com>
- enable tcl, rebuild against tcltk 8.3.1 (w/o pthreads).

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- include /lib/libdb.so in the devel package

* Wed May 10 2000 Jeff Johnson <jbj@redhat.com>
- put in "System Environment/Libraries" per msw instructions.

* Tue May  9 2000 Jeff Johnson <jbj@redhat.com>
- install shared library in /lib, not /usr/lib.
- move API docs to db3-devel.

* Mon May  8 2000 Jeff Johnson <jbj@redhat.com>
- don't rename db_* to db3_*.

* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
